データ構造とアルゴリズム:直前対策パック

公式集、全トピックの解法の要点、6 問の演習問題。完全な解答は巻末にあります。

新しい問題科目に戻る

印刷ウィンドウで「PDF として保存」を選ぶと、コピーを端末に保存できます。

1公式と解法

グラフ理論

握手補題
Σ deg(v) = 2|E|
完全グラフ
|E(Kn)| = n(n − 1)/2, |E(Km,n)| = m·n
正則グラフ
|E| = n·k/2
木と森
|E| = n − 1, |E| = n − c
木の葉
L = 2 + Σ (deg(v) − 2) over deg(v) ≥ 3
オイラー
閉路:すべての次数が偶数; 路:奇数次数がちょうど 2 つ
Kn のハミルトン閉路
(n − 1)!/2
ダイクストラ法の更新
d(v) = min(d(v), d(u) + w(u, v))
長さ L の歩道
(Mᴸ)ij

解き方

  1. 各頂点の次数を書き出します。次数の総和は辺の数の 2 倍になります。
  2. オイラーの問題では、グラフが連結であることを確かめ、奇数次数の頂点を数えます。
  3. 木では、辺が n − 1 本であることと握手補題を使います。
  4. ダイクストラ法では、暫定距離の表をつくり、毎回、未確定の頂点のうち最小のものを確定します。
  5. 最小全域木では、辺を重みの順に並べ、閉路をつくる辺を飛ばす方法(クラスカル法)か、始点から 1 本の木を成長させる方法(プリム法)を使います。

2演習問題

1.アルゴリズムと計算量ふつう

安定(stable)なソートアルゴリズムはどれですか?

  1. A選択ソート(一般的な版)
  2. Bヒープソート
  3. Cクイックソート(一般的なインプレース版)
  4. Dマージソート
2.アルゴリズムと計算量むずかしい

単方向連結リストでは、二分探索が O(log n) 時間にならないのはなぜですか?

  1. A二分探索には少なくとも 2 倍のメモリが必要だから
  2. Bインデックスによる直接アクセスがないので、中央の要素に到達するのに O(n) ステップかかるから
  3. C連結リストのノードでの比較は遅いから
  4. D連結リストはソートできないから
3.データ構造ふつう

循環バッファ(リングバッファ)は一般的に何を実装するために使われますか。

  1. Aハッシュ関数
  2. B二分探索木
  3. C固定サイズのキュー
  4. Dグラフ探索
4.データ構造むずかしい

標準的なブルームフィルタから、ビットをクリアするだけで要素を削除できないのはなぜですか。

  1. A削除すると偽陽性率が 100% に上がるから
  2. Bブルームフィルタは要素全体を格納しており、いったんハッシュ化されると再び見つけられないから
  3. Cそれらのビットは他の要素にも属している可能性があり、偽陰性を引き起こすから
  4. Dブルームフィルタのビットは作成後に変更できないから
5.グラフ理論ふつう

木に 次数 3 の頂点が 2 個, 次数 4 の頂点が 3 個, 次数 5 の頂点が 4 個, 次数 2 の頂点が 4 個 があり、ほかのすべての頂点は葉(次数 1)です。葉は何枚Lありますか?

2 × deg 33 × deg 44 × deg 54 × deg 2
L =
6.グラフ理論むずかしい
3462661410814ABCDEFG

ダイクストラ法を使って、重み付きグラフで A から F までの最短経路の長さd(F)を求めてください。

始点:A終点:F
d(F) =

3溶液

1.アルゴリズムと計算量

答え: D · マージソート

これが答えになる理由

マージソートは、値が等しいときに左半分から先に取り出すようにマージすれば安定です。インプレースのクイックソート、ヒープソート、選択ソートは通常安定ではありません。

答え

D · マージソート
2.アルゴリズムと計算量

答え: B · インデックスによる直接アクセスがないので、中央の要素に到達するのに O(n) ステップかかるから

これが答えになる理由

二分探索には中央への O(1) のアクセスが必要です。連結リストではそこまでたどるのに線形時間がかかるので、全体は O(n) になります。

答え

B · インデックスによる直接アクセスがないので、中央の要素に到達するのに O(n) ステップかかるから
3.データ構造

答え: C · 固定サイズのキュー

これが答えになる理由

リングバッファは回り込む head と tail のインデックスを使い、固定メモリで O(1) の enqueue と dequeue を実現します。

答え

C · 固定サイズのキュー
4.データ構造

答え: C · それらのビットは他の要素にも属している可能性があり、偽陰性を引き起こすから

これが答えになる理由

共有されたビットをクリアすると、別の要素が存在しないように見えてしまいます。カウンティング・ブルームフィルタは削除を可能にするために、ビットの代わりにカウンタを保持します。

答え

C · それらのビットは他の要素にも属している可能性があり、偽陰性を引き起こすから
5.グラフ理論

答え: L = 22

オイラー、ハミルトン、木:連結グラフは、すべての頂点の次数が偶数のときオイラー閉路(すべての辺を 1 回ずつ通って始点に戻る)をもち、ちょうど 2 つの頂点の次数が奇数のとき、閉路でないオイラー路をもちます。その路は、一方の奇数次数の頂点から他方へ通ります。ハミルトン閉路はすべての頂点を 1 回ずつ訪れ、Kn には (n − 1)!/2 個あります。n 個の頂点をもつ木には n − 1 本の辺があり、m 本の辺をもつ連結グラフは、m − n + 1 本の辺を取り除いても全域木が残ります。

木の握手補題

L + 46 = 2(L + 13) − 2
L = 22

答え

L = 22

近道:次数 d ≥ 3 の頂点について L = 2 + Σ (d − 2) です。

6.グラフ理論

答え: d(F) = 15

最短経路と全域木:ダイクストラ法は毎ラウンド 1 つの頂点を確定します:暫定距離が最小の未確定の頂点です。その距離は最終となり、各隣接頂点 v は d(v) = min(d(v), d(u) + w(u, v)) と更新されます。クラスカル法は、辺を軽い順に取り、閉路をつくる辺を飛ばして最小全域木をつくります。プリム法は、始点から 1 本の木を成長させ、その木から出る最も軽い辺を常に加えます。n 個の頂点の全域木には n − 1 本の辺があります。

ダイクストラ法をラウンドごとに

各行:確定した頂点、その最終距離、距離が改善される隣接頂点。

A (0): B: 3, C: 4
B (3): D: 9, G: 13
C (4): E: 6
E (6): F: 20
D (9): F: 15
G (13)
F (15)

最短経路

A → B → D → F
d(F) = 15

答え

d(F) = 15

ExamProblems · examproblems.com/courses/data-structures-and-algorithms